/*
**	io.c
*/
#include "deconv.h"
#include "xi.h"
#define NoWs 3

static struct wa aa[NoWs];
int rm,gm,bm;
int rs,gs,bs;
Ui tbc[TL];
int my[CN];
int mu[CN];
int mv[CN];
int mc[CN];
int cmr[CN];
int cmg[CN];
int cmb[CN];
int scr,lbp,dep;
int fg_pix, bg_pix;
Ui *zlinebuff;
static int expd[10]={64,57,57,0,33,57,57,57,57,-7};
int dh,dw;
Clp Q;
char *dd;
Window rt;
Display *dpy;
Colormap map,dmap;
XColor c1;
XEvent pe;
XGCValues xgcv;
XSetWindowAttributes xswa;
XWindowAttributes xwa;
XFontStruct *font_info;
Visual  *vis;
int bright= 0, contrast= 1<<16;
int cost= 1<<16, sint= 0;
#ifdef SH_MEM
int	shm= 1;
int	CompletionType= -1;
static int	gXErrorFlag= 0;

int
HandleXError(Display *dpy, XErrorEvent *event)
{ gXErrorFlag = 1; return 0; }
#endif

void
create_image(struct wa *w,int x,int y)
{
	if(x< 8)x= 8;
	if(y==0)y= 1;
#ifdef SH_MEM
	shm= XShmQueryExtension(dpy);
	if(shm){
	XSetErrorHandler(HandleXError); XFlush(dpy);
	CompletionType = XShmGetEventBase(dpy)+ShmCompletion;

	w->xi= XShmCreateImage(dpy,vis,dep,ZPixmap,NULL,&(w->shminfo),x,y);
	if(w->xi==NULL)goto shm_xci_err;

	w->shminfo.shmid =
	shmget(IPC_PRIVATE,((w->xi)->bytes_per_line*(w->xi)->height),IPC_CREAT|0777);
	if (w->shminfo.shmid<0){fprintf(stderr,"Seg.id.%d\n",w->shminfo.shmid);
				goto shm_seg_err;}
	(w->xi)->data= w->shminfo.shmaddr= (char *)shmat(w->shminfo.shmid,0,0);
	if(w->shminfo.shmaddr==((char *)-1)){
		fprintf(stderr,"Address.\n"); goto shm_adr_err;
	}
	w->shminfo.readOnly = False;

	XShmAttach(dpy, &(w->shminfo));
	XSync(dpy, False);
	shmctl(w->shminfo.shmid, IPC_RMID, 0);
	XSetErrorHandler(NULL); XFlush(dpy);

	if(dep>16) lbp= 2;
	else if(dep> 8) lbp= 1;
	if(expd[ddt]&(1<<w->x2)) w->dd0= (char *)malloc((x*y)<<lbp);

	if(gXErrorFlag==0) return;
	shmdt(w->shminfo.shmaddr);
shm_adr_err: shmctl(w->shminfo.shmid, IPC_RMID, 0);
shm_seg_err: XDestroyImage(w->xi); w->xi= NULL;
shm_xci_err: fprintf(stderr, "Shared memory error, disabling.\n");
	 shm= 0;
	}
#endif
	w->xi= XCreateImage(dpy,vis,dep,ZPixmap,0,NULL,x,y,32,0);
	(w->xi)->data= (char *)malloc((w->xi)->bytes_per_line*(w->xi)->height);
}


void
destroy_image(struct wa *w)
{
#ifdef SH_MEM
	if(shm) XShmDetach(dpy, &(w->shminfo));
	XDestroyImage(w->xi);
	if(shm){
		shmdt(w->shminfo.shmaddr);
		shmctl(w->shminfo.shmid, IPC_RMID, 0);
	}
#else
	XDestroyImage(w->xi);
#endif
	w->xi= NULL;
}

/*
**	initialize color table
*/
#define T 256
#define U 512
#define clip(t) if(t<0)t=0;if(t>255)t=255
void
init_cl(ddt,x2)
{
	int i,t;
	rm= vis->red_mask;
	gm= vis->green_mask;
	bm= vis->blue_mask;
	for(i=0;i<32;i++) if((rm <<i)&0x80000000)break; rs= i;
	for(i=0;i<32;i++) if((gm <<i)&0x80000000)break; gs= i;
	for(i=0;i<32;i++) if((bm <<i)&0x80000000)break; bs= i;
	if(ddt==9)	// full color
	for(i= -T;i<U;i++){
		t= i;
		if(cmp)t= (contrast*t+bright)>>16;
		t= ((t-16)*299)>>8;
		clip(t);
		t<<=24;
		//t= i; clip(t); t<<=24;
		Q.r[i]= ((Ui)t>>rs)&rm;
		Q.g[i]= ((Ui)t>>gs)&gm;
		Q.b[i]= ((Ui)t>>bs)&bm;
	} else if((x2&1)==0)
	for(i= -T;i<U;i++){
#define M0	0
#define	M1	16
#define	M4	24
#define	M5	8
		Ui r,g,b;
		t= i-15+M0; clip(t);	g= (t&0xe0)>>3;
		if(t<32)t=32;		r= (t&0xe0);
		t= i-30+2*M0; clip(t);	b= (t&0xc0)>>6;
		
		t= i-15+M1; clip(t);	g|= (t&0xe0)<<5;
		if(t<32)t=32;		r|= (t&0xe0)<<8;
		t= i-30+2*M1; clip(t);	b|= (t&0xc0)<<2;

		t= i-15+M4; clip(t);	g|= (t&0xe0)<<13;
		if(t<32)t=32;		r|= (t&0xe0)<<16;
		t= i-30+2*M4; clip(t);	b|= (t&0xc0)<<10;

		t= i-15+M5; clip(t);	g|= (t&0xe0)<<21;
		if(t<32)t=32;		r|= (t&0xe0)<<24;
		t= i-30+2*M5; clip(t);	b|= (t&0xc0)<<18;
		Q.r[i]= r; Q.g[i]= g; Q.b[i]= b;
	}
	else if(x2==1)
	for(i= -T;i<U;i++){
		t= i-15; clip(t); Q.g[i]= (t & 0xe0)>>3;
		if(t<32)t=32;	  Q.r[i]= t & 0xe0;
		t= i-30; clip(t); Q.b[i]= t>>6;
	} else for(i= -T;i<U;i++) {/* x2==3 */
		Ul r,g,b;
#ifdef Long64
		long t;
#endif
		t= i-15+4; clip(t);	g= (t&0xe0)>>3;
		if(t<32)t=32;		r= (t&0xe0);
		t= i-30+2*4; clip(t);	b= (t&0xc0)>>6;
		
		t= i-15+12; clip(t);	g|= (t&0xe0)<<5;
		if(t<32)t=32;		r|= (t&0xe0)<<8;
		t= i-30+2*12; clip(t);	b|= (t&0xc0)<<2;

		t= i-15+28; clip(t);	g|= (t&0xe0)<<13;
		if(t<32)t=32;		r|= (t&0xe0)<<16;
		t= i-30+2*28; clip(t);	b|= (t&0xc0)<<10;

		t= i-15+20; clip(t);	g|= (t&0xe0)<<21;
		if(t<32)t=32;		r|= (t&0xe0)<<24;
		t= i-30+2*20; clip(t);	b|= (t&0xc0)<<18;
#ifdef Long64
		t= i-15+8; clip(t);	g|= (t&0xe0)<<(32-3);
		if(t<32)t=32;		r|= (t&0xe0)<<32;
		t= i-30+2*8; clip(t);	b|= (t&0xc0)<<(32-6);

		t= i-15+16; clip(t);	g|= (t&0xe0)<<(40-3);
		if(t<32)t=32;		r|= (t&0xe0)<<40;
		t= i-30+2*16; clip(t);	b|= (t&0xc0)<<(40-6);

		t= i-15+24; clip(t);	g|= (t&0xe0)<<(48-3);
		if(t<32)t=32;		r|= (t&0xe0)<<48;
		t= i-30+2*24; clip(t);	b|= (t&0xc0)<<(48-6);

		t= i-15+0; clip(t);	g|= (t&0xe0)<<(56-3);
		if(t<32)t=32;		r|= (t&0xe0)<<56;
		t= i-30+2*0; clip(t);	b|= (t&0xc0)<<(56-6);
		*((Ul *)(&Q)+ 256+i)=		r;
		*((Ul *)(&Q)+1024+i)=		g;
		*((Ul *)(&Q)+1024+768+i)=	b;
#else
		Q.r[i]= r; Q.g[i]= g; Q.b[i]= b;
		t= i-15+8; clip(t);	g= (t&0xe0)>>3;
		if(t<32)t=32;		r= (t&0xe0);
		t= i-30+2*8; clip(t);	b= (t&0xc0)>>6;

		t= i-15+16; clip(t);	g|= (t&0xe0)<<5;
		if(t<32)t=32;		r|= (t&0xe0)<<8;
		t= i-30+2*16; clip(t);	b|= (t&0xc0)<<2;

		t= i-15+24; clip(t);	g|= (t&0xe0)<<13;
		if(t<32)t=32;		r|= (t&0xe0)<<16;
		t= i-30+2*24; clip(t);	b|= (t&0xc0)<<10;

		t= i-15+0; clip(t);	g|= (t&0xe0)<<21;
		if(t<32)t=32;		r|= (t&0xe0)<<24;
		t= i-30+2*0; clip(t);	b|= (t&0xc0)<<18;
		Q.y[i]= r; Q.u[i]= g; Q.v[i]= b;
#endif
	}
	for(i= -T;i<U;i++){
		t= i; clip(t); Q.cl[i]= t; Q.sq[i]= i*i;
	}
}

XColor xc[CN];
void
color_map_set(int bgonly,int gdonly,struct wa *w)
	{
	int j,y,u,v,r,g,b;
	int /*offuv,*/begin,end;
	static int new=1;

	if(ddt==FullColor)return;
	if(new){ new= 0;
		c1.flags= DoRed|DoGreen|DoBlue;
		dmap= DefaultColormap(dpy,scr);
		if(wid) {
			XWindowAttributes wa;
			XGetWindowAttributes(dpy,wid,&wa);
			map= wa.colormap;
		} else  map= XCreateColormap(dpy,rt,vis,1);
	}

	if(gdonly) { begin= fg_pix; end= fg_pix+1; }
	else { begin= 0; if(bgonly) end= ICN; else end= CN; }

	for(j=begin;j<end;j++){
		xc[j].pixel= j;
		xc[j].flags= DoRed|DoGreen|DoBlue;
		if(j<ICN && bgc!=1){
			if(bgc==0) XQueryColor(dpy,dmap,&xc[j]);
			if(bgc==2) xc[j].red=xc[j].green=xc[j].blue= 0;
			if(bgc==3) xc[j].red=xc[j].green=xc[j].blue= j<<11;
			}
		else switch(ddt){
	case 8: r=g=b=j; goto save_cm;
	case 0: 
		r= (j&0xe0)+16;
		g= ((j&0x1c)<<3)+16;
		b= ((j&3)<<6)+32;
	save_cm: cmr[j]= r; cmg[j]= g; cmb[j]= b;
		Rgbrgb()
		if(j==ICN) r=g=b=0;
		xc[j].red= r<<8; xc[j].green= g<<8; xc[j].blue=  b<<8;
		}
		if(j==fg_pix && w->grid) xc[j].red=xc[j].green=xc[j].blue= 255<<8;
		}
	if(gdonly) XStoreColor(dpy,map,&xc[fg_pix]);
	else if(bgonly) XStoreColors(dpy,map,xc,ICN);
	else	        XStoreColors(dpy,map,xc,CN);
	}

/*
**	get visual
*/
static void
get_vis(struct wa *w)
{
	XVisualInfo vinfo;
	if(!(dpy= XOpenDisplay(""))){ fprintf(stderr,"XOpenDisplay error.\n"); exit(1); }
	scr= DefaultScreen(dpy);
	dep= DisplayPlanes(dpy,scr);
	rt=  RootWindow(dpy,scr);
	fg_pix= WhitePixel(dpy,scr);
	bg_pix= BlackPixel(dpy,scr);
	dh=  DisplayHeight(dpy,scr);
	dw=  DisplayWidth(dpy,scr);
	ddt= FullColor;
	if(dep<=8){
		if(XMatchVisualInfo(dpy,scr,8,PseudoColor,&vinfo)) { vis= vinfo.visual; ddt= 0; }
		else { fprintf(stderr,"Requires 8 bit PseudoColor visual\n"); exit(1); }
	} else {
		if(XMatchVisualInfo(dpy,scr,dep,TrueColor,&vinfo)) { vis = vinfo.visual; ddt= FullColor; }
		else { fprintf(stderr,"Requires %d bit TrueColor visual\n",dep); exit(1); }
	}
	//font_info= XLoadQueryFont(dpy,"times_italic10");
	if(!zlinebuff) zlinebuff= (Ui *)malloc(2048*4);
	init_cl(ddt,w->x2);
	if(ddt!=FullColor) { color_map_set(0,0,w); XInstallColormap(dpy,map); }
}

static void
init_window(struct wa *w,char *n,unsigned char *sif,int x,int y)
{
	//int i,j,u,v;
	static int a=0;
	w->x2= 1;
	if(!a) { a++; get_vis(w); }
	w->ddx= x; w->ddy= y;
	/*
	w->dx= (w->ddx+15)&(~15);
	w->dy= (w->ddy+15)&(~15);
	*/
	w->dx= w->ddx;
	w->dy= w->ddy;
	w->xys= w->dx*w->dy;
	w->wx= w->ddx*w->x2;
	w->wy= w->ddy*w->x2;
	//if(w->wx > dw-20)w->wx= dw-20;
	if(w->wy > dh-20)w->wy= dh-20;
	x= w->dx*w->x2; y= w->ddy*w->x2;
	//if(x > dw-20)x= dw-20;
	if(x&3)x-= x&3;
	if(y > dh-20)y= dh-20;
	if(y&1)y--;
	w->wix= x; w->wiy= y;

	if(w->xi) destroy_image(w);
	create_image(w,x,y);

	if(w->w) XDestroyWindow(dpy,w->w);
	w->w= XCreateWindow(dpy,rt,w->gx,w->gy,w->wx,w->wy,1,dep,InputOutput,vis,
		(CWEventMask|CWBackPixel|CWColormap|CWBackingStore), &xswa);

	XSelectInput(dpy, w->w, ButtonPressMask 
	//| StructureNotifyMask | ButtonReleaseMask | PointerMotionMask | ExposureMask
		);
	//XChangeProperty(dpy,w->w,XA_WM_NAME,XA_STRING,8,PropModeReplace,n,strlen(n));
	if(!w->gc) {
		xgcv.foreground = fg_pix;
		xgcv.plane_mask = AllPlanes;
		xgcv.fill_style = FillSolid;
		xgcv.function = GXcopy;
		xgcv.graphics_exposures = True;
		w->gc = XCreateGC(dpy, w->w, GCForeground | GCFunction | GCPlaneMask |
			GCFillStyle | GCGraphicsExposures, &xgcv);
	}
	XMapWindow(dpy, w->w);
	XMoveWindow(dpy,w->w,w->gx,w->gy);
}

/*
**	event treatment
*/
Pixmap pixmap;
static int ex= 2;
static int psfx, psfy;
int posx,posy;
static void events(XEvent *pe)
{
	int i; Window w= pe->xany.window;
	void ww(struct wa *w, char *sif, char *n);

	if(w==aa[2].w) {
		if(pe->xbutton.button==Button3 &&ex) ex--; else if(ex<5)ex++;
		aa[2].wx= psfx<<ex; aa[2].wy= psfy<<ex;
		XResizeWindow(dpy, aa[2].w, aa[2].wx, aa[2].wy);
	}
	else for(i=0;i<2;i++) if(w == aa[i].w) {
		/*if(pe->type == ButtonRelease) button_off(&aa[i]);
		else if(pe->type == ButtonPress) button_on(&aa[i]);
		else if(pe->type == MotionNotify) lever(&aa[i]);
		else if(pe->type == ConfigureNotify) var_size(&aa[i]);*/
		if(pe->type == ButtonPress) {
			if(pe->xbutton.button==Button3) aa[0].x2= aa[1].x2= 1;
			else {
				aa[1].posx= aa[0].posx= (pe->xbutton.x)&-4;
				aa[1].posy= aa[0].posy= (pe->xbutton.y)&-4;
				aa[0].x2= aa[1].x2= 2;
			}
			ww(&aa[0],aa[0].ucp,aa[0].n);
		}
	}
}

/*
**	write windows
*/
void
ww(struct wa *w, char *sif, char *n)
{
	//int i,j,c;
	int t,tw=0,th=0; char *s=NULL;
	void disp();
	void expand();

	dd= w->xi->data;
	XChangeProperty(dpy,w->w,XA_WM_NAME,XA_STRING,8,PropModeReplace,n,strlen(n));
	if((t=(expd[ddt]&(1<<w->x2)))) {
		s= dd; dd= w->dd0; tw= w->wx; w->wx= w->dx; th= w->wy; w->wy= w->ddy;
	}
	disp(sif,w->x2,ddt,w);
	if(t){
		w->wx= tw;w->wy= th;
		expand(w->dd0,s,w->wx,w->wy,lbp,zlinebuff,w->dx,w->wix,w->ddy,w->x2);
	}
	//if(w->grid){ mkgrid(w); w->grid--; }
	if(shm) {
		if(w->st) do{ XNextEvent(dpy, &pe); events(&pe); }
		while(pe.type!= CompletionType); 
		XShmPutImage(dpy,w->pixmap,w->gc,w->xi,0,0,0,0,w->wix,w->wiy,1);
	} else {
		if(w->st)
		while(XCheckMaskEvent(dpy, ButtonPressMask
	//| ButtonReleaseMask | PointerMotionMask | ExposureMask | StructureNotifyMask
		, &pe)) events(&pe);
 		XPutImage(dpy,w->pixmap,w->gc,w->xi,0,0,0,0,w->wix,w->wiy);
	}
	w->st= 1;
	XClearWindow(dpy,w->w);
}


/*
**	interface functions
*/
void iwt(char *n, Uc *s, int x, int y, int wd, int ht,int i) {
	struct wa *w= &aa[i];

	strcpy(w->n,n);
	w->ucp= s;
	w->gx= x; w->gy= y;
	if(i==2) { psfx= wd; psfy= ht; wd<<= ex; ht<<= ex; }
	init_window(w,n,s,wd,ht);
	if(i==2) { w->wx= wd; w->wy= ht; }
	w->pixmap= XCreatePixmap(dpy,w->w,wd,ht,dep);
	XSetWindowBackgroundPixmap(dpy,w->w,w->pixmap);
	if(i==2) {
		XSetForeground(dpy,w->gc,bg_pix);
		XFillRectangle(dpy,w->pixmap,w->gc,0,0,wd,ht);
	} else ww(w,s,n);
}

// write (estimate)
void wt(char *s,char *n) { struct wa *w= &aa[1]; if(w->w) ww(w,s,n); }


// write (psf)
void wtp(int x, int y, Dt m[y][x])
{
	Dt igamma(Dt);
	char n[32];
	struct wa *w= &aa[2];
	int i,j,e,f; Ui a;
	if(!w->w) return;
	e= w->wx/x;
	f= w->wy/y;
	sprintf(n,"PSFx%2d",1<<ex);
	XChangeProperty(dpy,w->w,XA_WM_NAME,XA_STRING,8,PropModeReplace,n,strlen(n));
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc,i*e,j*f,e,f);
	}
	XClearWindow(dpy,w->w);
}

void wtp4(int x, int y, Dt m[4][y][x])
{
	Dt igamma(Dt);
	char n[32];
	struct wa *w= &aa[2];
	int i,j,k,e,f; Ui a;
	if(!w->w) return;
	e= w->wx/x/2;
	f= w->wy/y/2;
	sprintf(n,"PSFx%2d",1<<ex);
	XChangeProperty(dpy,w->w,XA_WM_NAME,XA_STRING,8,PropModeReplace,n,strlen(n));
	for(k=0;k<4;k++)
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m[k][j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc,
		((k&1)?w->wx/2:0)+i*e, ((k&2)?w->wy/2:0)+j*f, e,f);
	}
	XClearWindow(dpy,w->w);
}

void wtp42(int x, int y, Dt m0[y][x], Dt m1[y][x], Dt m2[y][x], Dt m3[y][x])
{
	Dt igamma(Dt);
	char n[32];
	struct wa *w= &aa[2];
	int i,j,e,f; Ui a;
	if(!w->w) return;
	e= w->wx/x/2;
	f= w->wy/y/2;
	sprintf(n,"PSFx%2d",1<<ex);
	XChangeProperty(dpy,w->w,XA_WM_NAME,XA_STRING,8,PropModeReplace,n,strlen(n));

	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m0[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, 0+i*e, 0+j*f, e,f);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m1[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, w->wx/2+i*e, 0+j*f, e,f);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m2[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, 0+i*e, w->wy/2+j*f, e,f);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m3[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, w->wx/2+i*e, w->wy/2+j*f, e,f);
	}
	XClearWindow(dpy,w->w);
}

void wtp9(int x, int y, Dt *i0, Dt *i1, Dt *i2, Dt *i3, Dt *i4, Dt *i5, Dt *i6, Dt *i7, Dt *i8)
{
	Dt igamma(Dt);

	Dt (*m0)[x]= (Dt (*)[x])i0;
	Dt (*m1)[x]= (Dt (*)[x])i1;
	Dt (*m2)[x]= (Dt (*)[x])i2;
	Dt (*m3)[x]= (Dt (*)[x])i3;
	Dt (*m4)[x]= (Dt (*)[x])i4;
	Dt (*m5)[x]= (Dt (*)[x])i5;
	Dt (*m6)[x]= (Dt (*)[x])i6;
	Dt (*m7)[x]= (Dt (*)[x])i7;
	Dt (*m8)[x]= (Dt (*)[x])i8;

	char n[32];
	struct wa *w= &aa[2];
	int i,j,e,f; Ui a;
	if(!w->w) return;
	e= w->wx/x;
	f= w->wy/y;
	sprintf(n,"PSFx%2d",1<<ex);
	XChangeProperty(dpy,w->w,XA_WM_NAME,XA_STRING,8,PropModeReplace,n,strlen(n));
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m0[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, 0+i*e/3, j*f/3, e/3,f/3);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m1[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, (w->wx+i*e)/3, j*f/3, e/3,f/3);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m2[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, (w->wx*2+i*e)/3, j*f/3, e/3,f/3);
	}

	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m3[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, i*e/3, (w->wy+j*f)/3, e/3,f/3);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m4[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, (w->wx+i*e)/3, (w->wy+j*f)/3, e/3,f/3);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m5[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, (w->wx*2+i*e)/3, (w->wy+j*f)/3, e/3,f/3);
	}

	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m6[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, i*e/3, (w->wy*2+j*f)/3, e/3,f/3);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m7[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, (w->wx+i*e)/3, (w->wy*2+j*f)/3, e/3,f/3);
	}
	for(j=0;j<y;j++)
	for(i=0;i<x;i++) {
		a= (int)igamma(m8[j][i]*x*y/8)<<24;
		XSetForeground(dpy,w->gc, ((a>>rs)&rm)|((a>>gs)&gm)|((a>>bs)&bm));
		XFillRectangle(dpy,w->pixmap,w->gc, (w->wx*2+i*e)/3, (w->wy*2+j*f)/3, e/3,f/3);
	}
	XClearWindow(dpy,w->w);
}

